package edu.cmu.cs.able.examples.RMI;
import java.rmi.*;
import java.util.*;
import javax.swing.*;

import java.net.*;
import java.io.*;

import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.RMI.*;

public class RMIAcmeGaugeConsumer extends RMIGaugeConsumer {

	private GaugeConsumerGUI theGaugeConsumerGUI;	
		
	public RMIAcmeGaugeConsumer()
	{
		super();
		try {
			gaugeBus = new RMIGaugeReportingBus ("localhost:1099");
			theGaugeConsumerGUI = new GaugeConsumerGUI(this);
			int p = Initialization.startGaugeConsumerService(this);			
			gaugeBus.registerGaugeConsumer(gaugeConsumerUID, p);			
			theGaugeConsumerGUI.display();
		}
		catch (Exception e) {
		}
	}


	public static void main(String args[]) {
		Global.initLookAndFeel("Metal");
		RMIAcmeGaugeConsumer theAcmeGaugeConsumer = new RMIAcmeGaugeConsumer();
		//theAcmeGaugeConsumer.createGauge();
	}


	public void addGauge(GaugeID theGaugeID, StringPairVector configParams)
	{
		theGaugeConsumerGUI.addGauge(theGaugeID, configParams);
	}

	public void addGauge(GaugeID theGaugeID)
	{
		//StringPairVector configParams = new StringPairVector();
		try {
			theGaugeConsumerGUI.addGauge(theGaugeID);
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

    public void onReportValue(GaugeControl gauge, String valueName, String propertyName, String value)
    {
    	theGaugeConsumerGUI.addReportedValue(gauge.getGaugeID().uid, valueName+value);
    }

    public void onReportConfigured(GaugeControl gauge, StringPairVector configParams)
    {
    	theGaugeConsumerGUI.changeConfig(gauge.getGaugeID().uid, configParams);
    }

    public void onReportDeleted(GaugeControl gauge)
    {
    	theGaugeConsumerGUI.deleteGauge(gauge.getGaugeID().uid);
    }

	
}
