package edu.cmu.cs.able.gauges.RMI;
import java.rmi.*;
import java.util.*;

import java.net.*;
import java.io.*;

import edu.cmu.cs.able.gaugeInfrastructure.*;
import edu.cmu.cs.able.gaugeInfrastructure.util.*;
import edu.cmu.cs.able.gaugeInfrastructure.RMI.*;

public class RMITimeGaugeMgr extends RMIGaugeMgr {
    
    /** Creates new RMITimeGaugeMgr */
    public RMITimeGaugeMgr(String bushost) {
        super(bushost);
        try {
            gaugeBus = new RMIGaugeReportingBus(bushost);
            gaugeMgrType = "edu.cmu.cs.able.gauges.RMI.RMITimeGauge";
            gaugeMgrUID = Global.generateUID();
            String host = Initialization.startGaugeMgrService(this);
            gaugeBus.registerGaugeMgr(gaugeMgrUID, gaugeMgrType, host);
            /*GaugeID gaugeID = new GaugeID();
            gaugeID.gaugeName = "RMITimeGaugeName";
            gaugeID.gaugeType = gaugeMgrType;
            gaugeID.modelName = "RMITimeGaugeModelName";
            gaugeID.modelType = "RMITimeGaugeModelType";
            gaugeID.uid = "";
            createGauge(gaugeID, null, null);*/
        }
        catch (Exception e) {}
    }
    /** Creates a new gauge as a separate process.
     * @param gauge The ID of the gauge to create.
     * @param setupParams The setup parameters to pass to the new gauge.
     * @param mappings The mappings to pass to the new gauge.
     * @return A gauge control that has the new ID and setup parameters.
     */    
    public GaugeControl createGauge(GaugeID gauge, StringPairVector setupParams, StringPairVector mappings) {
    	String setup = "";
    	for (int i = 0; i < setupParams.size()-1; i++) {
    		setup = setup+setupParams.nameAt(i)+"="+setupParams.valueAt(i)+" ";
    	}
    	if ( setupParams.size() > 0) {
    		setup = setup+setupParams.nameAt( setupParams.size()-1)+"="+setupParams.valueAt( setupParams.size()-1);
    	}
    		
    	String cmd = "java  "+gauge.gaugeType+" -gn "+gauge.gaugeName+" -gt "+gauge.gaugeType+" -mn "+gauge.modelName+" -mt "+gauge.modelType+" -setup "+setup; 
    	
        Global.exec(cmd);
        String host = null;
        int timeout = 20;
        try {
            host = gaugeBus.getGaugeHost(gauge);
            while (host == null && timeout > 0) {
                Thread.sleep(100);
                timeout--;
                host = gaugeBus.getGaugeHost(gauge);
            }
        }
        catch (Exception e) {}
        
        System.err.println(host);
        RMIGaugeHandle gh = new RMIGaugeHandle(host);
        return gh;
    }
    
    
    public static void main(String args[]) {
		if (args.length < 1) {
			System.err.println("Eventbus host missing");
			return;
		}
		
        RMITimeGaugeMgr theTimeGaugeMgr = new RMITimeGaugeMgr(args[0]);
    }
}

